include "basics/pts.ma".
include "bool.ma".
include "connectives.ma".
include "leibniz.ma".
include "logic.ma".
include "nat.ma".
definition sameF_upto : \forall A : Type[0] . nat -> (nat -> A) -> (nat -> A) -> Prop := \lambda A : Type[0]. \lambda k : nat. \lambda f : nat -> A. \lambda g : nat -> A. \forall (i:nat). ((lt)  i k) -> (eq) (A) (f i) (g i).
definition sameF_p : \forall A : Type[0] . nat -> (nat -> bool) -> (nat -> A) -> (nat -> A) -> Prop := \lambda A : Type[0]. \lambda k : nat. \lambda p : nat -> bool. \lambda f : nat -> A. \lambda g : nat -> A. \forall (i:nat). ((lt)  i k) -> ((eq) (bool) (p i) (true) ) -> (eq) (A) (f i) (g i).
definition sameF_upto_le : \forall A. \forall (f:nat -> A). \forall (g:nat -> A). \forall (n:nat). \forall (m:nat). ((le)  n m) -> ((sameF_upto) (A) m f g) -> (sameF_upto) (A) n f g := \lambda A : Type[0]. \lambda f : nat -> A. \lambda g : nat -> A. \lambda n : nat. \lambda m : nat. \lambda lenm : (le)  n m. (\lambda samef : (sameF_upto) (A) m f g. (\lambda i : nat. \lambda ltin : (lt)  i n. (((samef) (i)) ((((((lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))))).
definition sameF_p_le : \forall A. \forall (p:nat -> bool). \forall (f:nat -> A). \forall (g:nat -> A). \forall (n:nat). \forall (m:nat). ((le)  n m) -> ((sameF_p) (A) m p f g) -> (sameF_p) (A) n p f g := \lambda A : Type[0]. \lambda p : nat -> bool. \lambda f : nat -> A. \lambda g : nat -> A. \lambda n : nat. \lambda m : nat. \lambda lenm : (le)  n m. (\lambda samef : (sameF_p) (A) m p f g. (\lambda i : nat. \lambda ltin : (lt)  i n. (\lambda pi : (eq) (bool) (p i) (true) . ((((samef) (i)) ((((((lt_to_le_to_lt) (i)) (n)) (m)) (ltin)) (lenm))) (((((((rewrite_r) (bool)) ((true) )) (\lambda j__ : bool. (eq) (bool) j__ (true) )) (((refl) (bool)) ((true) ))) (p i)) (pi)))))).
axiom bigop : \forall H : Type[0] . nat -> (nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H.
axiom bigop_body : \forall H : Type[0] . nat -> (nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H.
axiom axiom_bigop_O : \forall H. (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop) (H) (O) ) ((bigop_body) (H) (O) ).
definition eq_bigop_O : \forall H. (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop) (H) (O) ) ((bigop_body) (H) (O) ) := \lambda H : Type[0]. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop) (H) (O) )) ((bigop_body) (H) (O) )) ((axiom_bigop_O) (H)).
definition sym_eq_bigop_O : \forall H. (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) (O) ) ((bigop) (H) (O) ) := \lambda H : Type[0]. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop) (H) (O) )) ((bigop_body) (H) (O) )) ((eq_bigop_O) (H)).
axiom axiom_bigop_S : \forall H. \forall (n:nat). (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop) (H) ((S)  n)) ((bigop_body) (H) ((S)  n)).
definition eq_bigop_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop) (H) ((S)  n)) ((bigop_body) (H) ((S)  n)) := \lambda H : Type[0]. \lambda n : nat. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop) (H) ((S)  n))) ((bigop_body) (H) ((S)  n))) (((axiom_bigop_S) (H)) (n)).
definition sym_eq_bigop_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) ((S)  n)) ((bigop) (H) ((S)  n)) := \lambda H : Type[0]. \lambda n : nat. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop) (H) ((S)  n))) ((bigop_body) (H) ((S)  n))) (((eq_bigop_S) (H)) (n)).
axiom axiom_bigop_body_O : \forall H. (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) (O) ) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil).
definition eq_bigop_body_O : \forall H. (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) (O) ) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil) := \lambda H : Type[0]. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) (O) )) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil)) ((axiom_bigop_body_O) (H)).
definition sym_eq_bigop_body_O : \forall H. (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil) ((bigop_body) (H) (O) ) := \lambda H : Type[0]. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) (O) )) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. nil)) ((eq_bigop_body_O) (H)).
axiom axiom_bigop_body_S : \forall H. \forall (n:nat). (equal) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) ((S)  n)) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)).
definition eq_bigop_body_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) ((bigop_body) (H) ((S)  n)) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)) := \lambda H : Type[0]. \lambda n : nat. ((((equal_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) ((S)  n))) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n))) (((axiom_bigop_body_S) (H)) (n)).
definition sym_eq_bigop_body_S : \forall H. \forall (n:nat). (leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n)) ((bigop_body) (H) ((S)  n)) := \lambda H : Type[0]. \lambda n : nat. ((((sym_leibniz) ((nat -> bool) -> H -> (H -> H -> H) -> (nat -> H) -> H)) ((bigop_body) (H) ((S)  n))) (\lambda p : nat -> bool. \lambda nil : H. \lambda op : H -> H -> H. \lambda f : nat -> H. (match_bool_type) (H) (op (f n) ((bigop) (H) n p nil op f)) ((bigop) (H) n p nil op f) (p n))) (((eq_bigop_body_S) (H)) (n)).
definition bigop_Strue : \forall B. \forall (k:nat). \forall (p:nat -> bool). \forall (nil:B). \forall (op:B -> B -> B). \forall (f:nat -> B). ((eq) (bool) (p k) (true) ) -> (eq) (B) ((bigop) (B) ((S)  k) (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) := \lambda B : Type[0]. \lambda k : nat. \lambda p : nat -> bool. \lambda nil : B. \lambda op : B -> B -> B. \lambda f : nat -> B. ((((sym_eq_bigop_S) (B)) (k)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((eq) (bool) (p k) (true) ) -> (eq) (B) (y (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))))) (((((sym_eq_bigop_body_S) (B)) (k)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((eq) (bool) (p k) (true) ) -> (eq) (B) (y (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))))) (\lambda H : (eq) (bool) (p k) (true) . (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (B) ((match_bool_type) (B) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) x) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))))) ((((((eq_match_bool_type_true) (B)) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)))) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) (\lambda y : B. (eq) (B) ((match_bool_type) (B) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) (true) ) y)) (((refl) (B)) ((match_bool_type) (B) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) (true) )))) (p k)) (H)))).
definition bigop_Sfalse : \forall B. \forall (k:nat). \forall (p:nat -> bool). \forall (nil:B). \forall (op:B -> B -> B). \forall (f:nat -> B). ((eq) (bool) (p k) (false) ) -> (eq) (B) ((bigop) (B) ((S)  k) (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) := \lambda B : Type[0]. \lambda k : nat. \lambda p : nat -> bool. \lambda nil : B. \lambda op : B -> B -> B. \lambda f : nat -> B. ((((sym_eq_bigop_S) (B)) (k)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((eq) (bool) (p k) (false) ) -> (eq) (B) (y (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)))) (((((sym_eq_bigop_body_S) (B)) (k)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((eq) (bool) (p k) (false) ) -> (eq) (B) (y (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)))) (\lambda H : (eq) (bool) (p k) (false) . (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (B) ((match_bool_type) (B) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) x) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)))) ((((((eq_match_bool_type_false) (B)) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)))) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) (\lambda y : B. (eq) (B) ((match_bool_type) (B) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) (false) ) y)) (((refl) (B)) ((match_bool_type) (B) (op (f k) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i))) ((bigop) (B) k (\lambda i : nat. p i) nil op (\lambda i : nat. f i)) (false) )))) (p k)) (H)))).
definition same_bigop : \forall B. \forall (k:nat). \forall (p1:nat -> bool). \forall (p2:nat -> bool). \forall (nil:B). \forall (op:B -> B -> B). \forall (f:nat -> B). \forall (g:nat -> B). ((sameF_upto) (bool) k p1 p2) -> ((sameF_p) (B) k p1 f g) -> (eq) (B) ((bigop) (B) k (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) k (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) := \lambda B : Type[0]. \lambda k : nat. \lambda p1 : nat -> bool. \lambda p2 : nat -> bool. \lambda nil : B. \lambda op : B -> B -> B. \lambda f : nat -> B. \lambda g : nat -> B. ((((nat_ind) (\lambda j_x_365 : nat. ((sameF_upto) (bool) j_x_365 p1 p2) -> ((sameF_p) (B) j_x_365 p1 f g) -> (eq) (B) ((bigop) (B) j_x_365 (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) j_x_365 (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((((sym_eq_bigop_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((sameF_upto) (bool) (O)  p1 p2) -> ((sameF_p) (B) (O)  p1 f g) -> (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((((sym_eq_bigop_body_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((sameF_upto) (bool) (O)  p1 p2) -> ((sameF_p) (B) (O)  p1 f g) -> (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((((eq_bigop_body_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((sameF_upto) (bool) (O)  p1 p2) -> ((sameF_p) (B) (O)  p1 f g) -> (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)))) ((((eq_bigop_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. ((sameF_upto) (bool) (O)  p1 p2) -> ((sameF_p) (B) (O)  p1 f g) -> (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)))) (\lambda auto : (sameF_upto) (bool) (O)  p1 p2. (\lambda auto' : (sameF_p) (B) (O)  p1 f g. (((refl) (B)) ((bigop) (B) (O)  (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)))))))))) (\lambda n : nat. ((((sym_eq_bigop_S) (B)) (n)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) -> ((sameF_upto) (bool) ((S)  n) p1 p2) -> ((sameF_p) (B) ((S)  n) p1 f g) -> (eq) (B) ((bigop) (B) ((S)  n) (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) (((((sym_eq_bigop_S) (B)) (n)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) -> ((sameF_upto) (bool) ((S)  n) p1 p2) -> ((sameF_p) (B) ((S)  n) p1 f g) -> (eq) (B) (y (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop_body) (B) ((S)  n) (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) (((((sym_eq_bigop_body_S) (B)) (n)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) -> ((sameF_upto) (bool) ((S)  n) p1 p2) -> ((sameF_p) (B) ((S)  n) p1 f g) -> (eq) (B) (y (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop_body) (B) ((S)  n) (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) (((((sym_eq_bigop_body_S) (B)) (n)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) -> ((sameF_upto) (bool) ((S)  n) p1 p2) -> ((sameF_p) (B) ((S)  n) p1 f g) -> (eq) (B) (((\lambda p : nat -> bool. \lambda nil0 : B. \lambda op0 : B -> B -> B. \lambda f0 : nat -> B. (match_bool_type) (B) (op0 (f0 n) ((bigop) (B) n p nil0 op0 f0)) ((bigop) (B) n p nil0 op0 f0) (p n)) (\lambda i : nat. p1 i)) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) (\lambda Hind : ((sameF_upto) (bool) n p1 p2) -> ((sameF_p) (B) n p1 f g) -> (eq) (B) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)). (\lambda samep : (sameF_upto) (bool) ((S)  n) p1 p2. (\lambda samef : (sameF_p) (B) ((S)  n) p1 f g. (((((((eq_ind_r) (B)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda x : B. (eq) (B) ((match_bool_type) (B) (op (f n) x) x (p1 n)) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (p2 n)))) (((((((eq_ind) (bool)) (p1 n)) (\lambda x_1 : bool. (eq) (B) ((match_bool_type) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (p1 n)) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x_1))) (((((((match_Or_prop) ((eq) (bool) (p1 n) (true) )) ((eq) (bool) (p1 n) (false) )) ((eq) (B) ((match_bool_type) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (p1 n)) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (p1 n)))) (\lambda H1 : (eq) (bool) (p1 n) (true) . (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (B) ((match_bool_type) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x))) ((((((sym_eq_match_bool_type_true) (B)) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda y : B. (eq) (B) y ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (true) ))) ((((((sym_eq_match_bool_type_true) (B)) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda y : B. (eq) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) y)) (((((((eq_ind) (B)) (f n)) (\lambda x_1 : B. (eq) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (op x_1 ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))))) (((refl) (B)) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))))) (g n)) ((((samef) (n)) ((le_n) ((S)  n))) (H1)))))) (p1 n)) (H1)))) (\lambda H1 : (eq) (bool) (p1 n) (false) . (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (B) ((match_bool_type) (B) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x) ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) x))) ((((((sym_eq_match_bool_type_false) (B)) (op (f n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda y : B. (eq) (B) y ((match_bool_type) (B) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) (false) ))) ((((((sym_eq_match_bool_type_false) (B)) (op (g n) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i))) (\lambda y : B. (eq) (B) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)) y)) (((refl) (B)) ((bigop) (B) n (\lambda i : nat. p2 i) nil op (\lambda i : nat. g i)))))) (p1 n)) (H1)))) ((true_or_false) (p1 n)))) (p2 n)) (((samep) (n)) ((le_n) ((S)  n))))) ((bigop) (B) n (\lambda i : nat. p1 i) nil op (\lambda i : nat. f i))) (((Hind) ((((((((sameF_upto_le) (bool)) (p1)) (p2)) (n)) ((S)  n)) (((((eq_coerc) ((le)  ((pred)  ((S)  n)) ((S)  n))) ((le)  n ((S)  n))) ((le_pred_n) ((S)  n))) (((((((rewrite_l) (nat)) (n)) (\lambda j__ : nat. (eq) (Prop) ((le)  j__ ((S)  n)) ((le)  n ((S)  n)))) (((refl) (Prop)) ((le)  n ((S)  n)))) ((pred)  ((S)  n))) ((pred_Sn) (n))))) (samep))) (((((((((sameF_p_le) (B)) (p1)) (f)) (g)) (n)) ((S)  n)) (((((eq_coerc) ((le)  ((pred)  ((S)  n)) ((S)  n))) ((le)  n ((S)  n))) ((le_pred_n) ((S)  n))) (((((((rewrite_l) (nat)) (n)) (\lambda j__ : nat. (eq) (Prop) ((le)  j__ ((S)  n)) ((le)  n ((S)  n)))) (((refl) (Prop)) ((le)  n ((S)  n)))) ((pred)  ((S)  n))) ((pred_Sn) (n))))) (samef)))))))))))) (k).
definition bigop_false : \forall B. \forall (n:nat). \forall (nil:B). \forall (op:B -> B -> B). \forall (f:nat -> B). (eq) (B) ((bigop) (B) n (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i)) nil := \lambda B : Type[0]. \lambda n : nat. \lambda nil : B. \lambda op : B -> B -> B. \lambda f : nat -> B. ((((nat_ind) (\lambda j_x_365 : nat. (eq) (B) ((bigop) (B) j_x_365 (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i)) nil)) ((((eq_bigop_body_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i)))) ((((eq_bigop_O) (B)) (\lambda y : (nat -> bool) -> B -> (B -> B -> B) -> (nat -> B) -> B. (eq) (B) ((bigop) (B) (O)  (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i)) (y (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i)))) (((refl) (B)) ((bigop) (B) (O)  (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i)))))) (\lambda n1 : nat. \lambda Hind : (eq) (B) ((bigop) (B) n1 (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i)) nil. (((((((eq_ind_r) (B)) ((bigop) (B) n1 (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i))) (\lambda x : B. (eq) (B) x nil)) (((((((rewrite_r) (B)) (nil)) (\lambda j__ : B. (eq) (B) j__ nil)) (((refl) (B)) (nil))) ((bigop) (B) n1 (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i))) (Hind))) ((bigop) (B) ((S)  n1) (\lambda i : nat. (false) ) nil op (\lambda i : nat. f i))) ((((((((bigop_Sfalse) (B)) (n1)) (\lambda j__ : nat. (false) )) (nil)) (op)) (f)) (((refl) (bool)) ((false) )))))) (n).
definition bigop_I_gen : \forall (a:nat). \forall (b:nat). \forall (p:nat -> bool). \forall (f:nat -> nat). ((le)  a b) -> (eq) (nat) ((bigop) (nat) ((minus)  b a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) b (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)) := \lambda a : nat. \lambda b : nat. ((((nat_ind) (\lambda j_x_365 : nat. \forall (p:nat -> bool). \forall (f:nat -> nat). ((le)  a j_x_365) -> (eq) (nat) ((bigop) (nat) ((minus)  j_x_365 a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) j_x_365 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) (\lambda p : nat -> bool. \lambda f : nat -> nat. (((sym_eq_bigop_O) (nat)) (\lambda y : (nat -> bool) -> nat -> (nat -> nat -> nat) -> (nat -> nat) -> nat. ((le)  a (O) ) -> (eq) (nat) ((bigop) (nat) ((minus)  (O)  a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) (y (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) ((((sym_eq_bigop_body_O) (nat)) (\lambda y : (nat -> bool) -> nat -> (nat -> nat -> nat) -> (nat -> nat) -> nat. ((le)  a (O) ) -> (eq) (nat) ((bigop) (nat) ((minus)  (O)  a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) (y (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) ((((eq_bigop_body_O) (nat)) (\lambda y : (nat -> bool) -> nat -> (nat -> nat -> nat) -> (nat -> nat) -> nat. ((le)  a (O) ) -> (eq) (nat) ((bigop) (nat) ((minus)  (O)  a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) (y (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))))) ((((eq_bigop_O) (nat)) (\lambda y : (nat -> bool) -> nat -> (nat -> nat -> nat) -> (nat -> nat) -> nat. ((le)  a (O) ) -> (eq) (nat) ((bigop) (nat) ((minus)  (O)  a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) (y (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))))) (((eq_minus_body_O) (\lambda y : nat -> nat. ((le)  a (O) ) -> (eq) (nat) ((bigop) (nat) ((minus)  (O)  a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) (y a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))))) (((((eq_filter_nat_type_O) (nat -> nat)) ((minus_body) )) (\lambda y : nat -> nat. ((le)  a (O) ) -> (eq) (nat) ((bigop) (nat) ((minus)  (O)  a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) (y a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))))) ((((eq_minus) ((O) )) (\lambda y : nat -> nat. ((le)  a (O) ) -> (eq) (nat) ((bigop) (nat) ((minus)  (O)  a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) (y a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))))) (\lambda auto : (le)  a (O) . (((refl) (nat)) ((bigop) (nat) ((minus)  (O)  a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))))))))))))) (\lambda b0 : nat. \lambda Hind : \forall (p:nat -> bool). \forall (f:nat -> nat). ((le)  a b0) -> (eq) (nat) ((bigop) (nat) ((minus)  b0 a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) b0 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)). (\lambda p : nat -> bool. \lambda f : nat -> nat. \lambda lea : (le)  a ((S)  b0). (((((((match_Or_prop) ((lt)  a ((S)  b0))) ((eq) (nat) a ((S)  b0))) ((eq) (nat) ((bigop) (nat) ((minus)  ((S)  b0) a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) ((S)  b0) (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) (\lambda Ha : (lt)  a ((S)  b0). (((((((match_Or_prop) ((eq) (bool) (p b0) (true) )) ((eq) (bool) (p b0) (false) )) ((eq) (nat) ((bigop) (nat) ((minus)  ((S)  b0) a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) ((S)  b0) (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) (\lambda Hcase : (eq) (bool) (p b0) (true) . (((((((eq_ind_r) (nat)) ((times)  (f b0) ((bigop) (nat) b0 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) (\lambda x : nat. (eq) (nat) ((bigop) (nat) ((minus)  ((S)  b0) a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) x)) (((((((eq_ind_r) (nat)) ((S)  ((minus)  b0 a))) (\lambda x : nat. (eq) (nat) ((bigop) (nat) x (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((times)  (f b0) ((bigop) (nat) b0 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i))))) (((((((eq_ind_r) (nat)) ((times)  (f ((plus)  ((minus)  b0 a) a)) ((bigop) (nat) ((minus)  b0 a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))))) (\lambda x : nat. (eq) (nat) x ((times)  (f b0) ((bigop) (nat) b0 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i))))) (((((((((((eq_f2) (nat)) (nat)) (nat)) ((times) )) (f ((plus)  ((minus)  b0 a) a))) (f b0)) ((bigop) (nat) ((minus)  b0 a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a)))) ((bigop) (nat) b0 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i))) (((((((eq_f) (nat)) (nat)) (f)) ((plus)  ((minus)  b0 a) a)) (b0)) (((((((eq_ind) (nat)) (b0)) (\lambda x_1 : nat. (eq) (nat) x_1 b0)) (((refl) (nat)) (b0))) ((plus)  ((minus)  b0 a) a)) ((((plus_minus_m_m) (b0)) (a)) ((((le_S_S_to_le) (a)) (b0)) (Ha)))))) ((((Hind) (p)) (f)) ((((le_S_S_to_le) (a)) (b0)) (Ha))))) ((bigop) (nat) ((S)  ((minus)  b0 a)) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a)))) ((((((((bigop_Strue) (nat)) ((minus)  b0 a)) (\lambda j__ : nat. p ((plus)  j__ a))) ((S)  (O) )) ((times) )) (\lambda j__ : nat. f ((plus)  j__ a))) (((((((eq_ind) (nat)) (b0)) (\lambda x_1 : nat. (eq) (bool) (p x_1) (true) )) (((((((rewrite_r) (bool)) ((true) )) (\lambda j__ : bool. (eq) (bool) j__ (true) )) (((refl) (bool)) ((true) ))) (p b0)) (Hcase))) ((plus)  ((minus)  b0 a) a)) ((((plus_minus_m_m) (b0)) (a)) ((((le_S_S_to_le) (a)) (b0)) (Ha))))))) ((minus)  ((S)  b0) a)) ((((((match_nat_prop) (\lambda j__ : nat. ((le)  j__ b0) -> (eq) (nat) ((minus)  ((S)  b0) j__) ((S)  ((minus)  b0 j__)))) (\lambda auto : (le)  (O)  b0. (((((((rewrite_l) (nat)) ((S)  b0)) (\lambda j__ : nat. (eq) (nat) j__ ((S)  ((minus)  b0 (O) )))) (((((((rewrite_l) (nat)) (b0)) (\lambda j__ : nat. (eq) (nat) ((S)  b0) ((S)  j__))) (((refl) (nat)) ((S)  b0))) ((minus)  b0 (O) )) ((minus_n_O) (b0)))) ((minus)  ((S)  b0) (O) )) ((minus_n_O) ((S)  b0))))) ((((sym_eq_minus) ((S)  b0)) (\lambda y : nat -> nat. \forall (n:nat). ((le)  ((S)  n) b0) -> (eq) (nat) (y ((S)  n)) ((S)  ((minus)  b0 ((S)  n))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) ((minus_body) )) (b0)) (\lambda y : nat -> nat. \forall (n:nat). ((le)  ((S)  n) b0) -> (eq) (nat) (y ((S)  n)) ((S)  ((minus)  b0 ((S)  n))))) (\lambda a1 : nat. (((sym_eq_minus_body_S) (b0)) (\lambda y : nat -> nat. ((le)  ((S)  a1) b0) -> (eq) (nat) (y ((S)  a1)) ((S)  ((minus)  b0 ((S)  a1))))) (((((((sym_eq_match_nat_type_S) (nat)) ((S)  b0)) (\lambda q : nat. (minus)  b0 q)) (a1)) (\lambda y : nat. ((le)  ((S)  a1) b0) -> (eq) (nat) y ((S)  ((minus)  b0 ((S)  a1))))) (\lambda lta1 : (le)  ((S)  a1) b0. (((((((eq_ind_r) (nat)) ((pred)  ((minus)  b0 a1))) (\lambda x : nat. (eq) (nat) ((minus)  b0 a1) ((S)  x))) (((((((eq_ind_r) (nat)) ((minus)  b0 a1)) (\lambda x : nat. (eq) (nat) ((minus)  b0 a1) x)) (((refl) (nat)) ((minus)  b0 a1))) ((S)  ((pred)  ((minus)  b0 a1)))) (((S_pred) ((minus)  b0 a1)) (((((lt_plus_to_minus_r) ((O) )) (a1)) (b0)) ((((sym_eq_plus) ((O) )) (\lambda y : nat -> nat. (le)  ((S)  (y a1)) b0)) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((plus_body) )) (\lambda y : nat -> nat. (le)  ((S)  (y a1)) b0)) (((sym_eq_plus_body_O) (\lambda y : nat -> nat. (le)  ((S)  (y a1)) b0)) (lta1)))))))) ((minus)  b0 ((S)  a1))) (((eq_minus_S_pred) (b0)) (a1))))))))) (a)) ((((le_S_S_to_le) (a)) (b0)) (Ha))))) ((bigop) (nat) ((S)  b0) (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i))) ((((((((bigop_Strue) (nat)) (b0)) (\lambda j__ : nat. (andb)  ((leb)  a j__) (p j__))) ((S)  (O) )) ((times) )) (f)) (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (bool) ((andb)  ((leb)  a b0) x) (true) )) (((((((eq_ind_r) (bool)) ((true) )) (\lambda x : bool. (eq) (bool) ((andb)  x (true) ) (true) )) ((((((eq_match_bool_type_true) (bool)) ((true) )) ((false) )) (\lambda y : bool. (eq) (bool) ((match_bool_type) (bool) (true)  (false)  (true) ) y)) (((refl) (bool)) ((andb)  (true)  (true) )))) ((leb)  a b0)) ((((le_to_leb_true) (a)) (b0)) ((((le_S_S_to_le) (a)) (b0)) (Ha))))) (p b0)) (Hcase)))))) (\lambda Hcase : (eq) (bool) (p b0) (false) . (((((((eq_ind_r) (nat)) ((bigop) (nat) b0 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i))) (\lambda x : nat. (eq) (nat) ((bigop) (nat) ((minus)  ((S)  b0) a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) x)) (((((((eq_ind_r) (nat)) ((S)  ((minus)  b0 a))) (\lambda x : nat. (eq) (nat) ((bigop) (nat) x (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) b0 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) (((((((eq_ind_r) (nat)) ((bigop) (nat) ((minus)  b0 a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a)))) (\lambda x : nat. (eq) (nat) x ((bigop) (nat) b0 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) ((((Hind) (p)) (f)) ((((le_S_S_to_le) (a)) (b0)) (Ha)))) ((bigop) (nat) ((S)  ((minus)  b0 a)) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a)))) ((((((((bigop_Sfalse) (nat)) ((minus)  b0 a)) (\lambda j__ : nat. p ((plus)  j__ a))) ((S)  (O) )) ((times) )) (\lambda j__ : nat. f ((plus)  j__ a))) (((((((eq_ind) (nat)) (b0)) (\lambda x_1 : nat. (eq) (bool) (p x_1) (false) )) (((((((rewrite_r) (bool)) ((false) )) (\lambda j__ : bool. (eq) (bool) j__ (false) )) (((refl) (bool)) ((false) ))) (p b0)) (Hcase))) ((plus)  ((minus)  b0 a) a)) ((((plus_minus_m_m) (b0)) (a)) ((((le_S_S_to_le) (a)) (b0)) (Ha))))))) ((minus)  ((S)  b0) a)) ((((((match_nat_prop) (\lambda j__ : nat. ((le)  j__ b0) -> (eq) (nat) ((minus)  ((S)  b0) j__) ((S)  ((minus)  b0 j__)))) (\lambda auto : (le)  (O)  b0. (((((((rewrite_l) (nat)) ((S)  b0)) (\lambda j__ : nat. (eq) (nat) j__ ((S)  ((minus)  b0 (O) )))) (((((((rewrite_l) (nat)) (b0)) (\lambda j__ : nat. (eq) (nat) ((S)  b0) ((S)  j__))) (((refl) (nat)) ((S)  b0))) ((minus)  b0 (O) )) ((minus_n_O) (b0)))) ((minus)  ((S)  b0) (O) )) ((minus_n_O) ((S)  b0))))) ((((sym_eq_minus) ((S)  b0)) (\lambda y : nat -> nat. \forall (n:nat). ((le)  ((S)  n) b0) -> (eq) (nat) (y ((S)  n)) ((S)  ((minus)  b0 ((S)  n))))) ((((((sym_eq_filter_nat_type_S) (nat -> nat)) ((minus_body) )) (b0)) (\lambda y : nat -> nat. \forall (n:nat). ((le)  ((S)  n) b0) -> (eq) (nat) (y ((S)  n)) ((S)  ((minus)  b0 ((S)  n))))) (\lambda a1 : nat. (((sym_eq_minus_body_S) (b0)) (\lambda y : nat -> nat. ((le)  ((S)  a1) b0) -> (eq) (nat) (y ((S)  a1)) ((S)  ((minus)  b0 ((S)  a1))))) (((((((sym_eq_match_nat_type_S) (nat)) ((S)  b0)) (\lambda q : nat. (minus)  b0 q)) (a1)) (\lambda y : nat. ((le)  ((S)  a1) b0) -> (eq) (nat) y ((S)  ((minus)  b0 ((S)  a1))))) (\lambda lta1 : (le)  ((S)  a1) b0. (((((((eq_ind_r) (nat)) ((pred)  ((minus)  b0 a1))) (\lambda x : nat. (eq) (nat) ((minus)  b0 a1) ((S)  x))) (((((((eq_ind_r) (nat)) ((minus)  b0 a1)) (\lambda x : nat. (eq) (nat) ((minus)  b0 a1) x)) (((refl) (nat)) ((minus)  b0 a1))) ((S)  ((pred)  ((minus)  b0 a1)))) (((S_pred) ((minus)  b0 a1)) (((((lt_plus_to_minus_r) ((O) )) (a1)) (b0)) ((((sym_eq_plus) ((O) )) (\lambda y : nat -> nat. (le)  ((S)  (y a1)) b0)) (((((sym_eq_filter_nat_type_O) (nat -> nat)) ((plus_body) )) (\lambda y : nat -> nat. (le)  ((S)  (y a1)) b0)) (((sym_eq_plus_body_O) (\lambda y : nat -> nat. (le)  ((S)  (y a1)) b0)) (lta1)))))))) ((minus)  b0 ((S)  a1))) (((eq_minus_S_pred) (b0)) (a1))))))))) (a)) ((((le_S_S_to_le) (a)) (b0)) (Ha))))) ((bigop) (nat) ((S)  b0) (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i))) ((((((((bigop_Sfalse) (nat)) (b0)) (\lambda j__ : nat. (andb)  ((leb)  a j__) (p j__))) ((S)  (O) )) ((times) )) (f)) (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (bool) ((andb)  ((leb)  a b0) x) (false) )) (((((match_bool_prop) (\lambda j__ : bool. (eq) (bool) ((andb)  j__ (false) ) (false) )) ((((((eq_match_bool_type_true) (bool)) ((false) )) ((false) )) (\lambda y : bool. (eq) (bool) ((match_bool_type) (bool) (false)  (false)  (true) ) y)) (((refl) (bool)) ((andb)  (true)  (false) )))) ((((((eq_match_bool_type_false) (bool)) ((false) )) ((false) )) (\lambda y : bool. (eq) (bool) ((match_bool_type) (bool) (false)  (false)  (false) ) y)) (((refl) (bool)) ((andb)  (false)  (false) )))) ((leb)  a b0))) (p b0)) (Hcase)))))) ((true_or_false) (p b0))))) (\lambda Ha : (eq) (nat) a ((S)  b0). (((((((eq_ind) (nat)) (a)) (\lambda x_1 : nat. (eq) (nat) ((bigop) (nat) ((minus)  x_1 a) (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) x_1 (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) (((((((eq_ind) (nat)) ((O) )) (\lambda x_1 : nat. (eq) (nat) ((bigop) (nat) x_1 (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) a (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) ((((sym_eq_bigop_O) (nat)) (\lambda y : (nat -> bool) -> nat -> (nat -> nat -> nat) -> (nat -> nat) -> nat. (eq) (nat) (y (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) a (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) ((((sym_eq_bigop_body_O) (nat)) (\lambda y : (nat -> bool) -> nat -> (nat -> nat -> nat) -> (nat -> nat) -> nat. (eq) (nat) (y (\lambda i : nat. p ((plus)  i a)) ((S)  (O) ) (times)  (\lambda i : nat. f ((plus)  i a))) ((bigop) (nat) a (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) (((((((eq_ind) (nat)) ((bigop) (nat) a (\lambda i : nat. (false) ) ((S)  (O) ) (times)  (\lambda i : nat. f i))) (\lambda x_1 : nat. (eq) (nat) x_1 ((bigop) (nat) a (\lambda i : nat. (andb)  ((leb)  a i) (p i)) ((S)  (O) ) (times)  (\lambda i : nat. f i)))) (((((((((((same_bigop) (nat)) (a)) (\lambda j__ : nat. (false) )) (\lambda j__ : nat. (andb)  ((leb)  a j__) (p j__))) ((S)  (O) )) ((times) )) (f)) (f)) (\lambda i : nat. \lambda ltia : (lt)  i a. (((((((eq_ind_r) (bool)) ((false) )) (\lambda x : bool. (eq) (bool) (false)  ((andb)  x (p i)))) ((((((sym_eq_match_bool_type_false) (bool)) (p i)) ((false) )) (\lambda y : bool. (eq) (bool) (false)  y)) (((refl) (bool)) ((false) )))) ((leb)  a i)) ((((not_le_to_leb_false) (a)) (i)) ((((lt_to_not_le) (i)) (a)) (ltia)))))) (\lambda i : nat. \lambda auto : (lt)  i a. (\lambda auto' : (eq) (bool) (false)  (true) . (((refl) (nat)) (f i)))))) ((S)  (O) )) ((((((bigop_false) (nat)) (a)) ((S)  (O) )) ((times) )) (f)))))) ((minus)  a a)) ((minus_n_n) (a)))) ((S)  b0)) (Ha)))) ((((le_to_or_lt_eq) (a)) ((S)  b0)) (lea)))))) (b).
